#include <stdlib.h>
#include <fcntl.h>
#include "prngd.h"

/*
 * Set or remove "close on exec" flag for file descriptor.'
 * Inspired by close_on_exec() function in Wietse Venema's Postfix.
 * On failure, there is nothing left what we can do.
 */
#define PATTERN FD_CLOEXEC

void close_on_exec(int fd, int on)
{
  int flags;

  if ((flags = fcntl(fd, F_GETFD, 0)) < 0)
    abort();
  if (fcntl(fd, F_SETFD, on ? flags | PATTERN : flags & ~PATTERN) < 0)
    abort();
}
